#include <stdio.h>

main(argc, argv)
   int argc;
   char *argv[];
{
  FILE *fd;
  FILE *fdout;
  float rate, prob;
  float maxRate;
  float step;
  int dummy;
  int ptCount;
  int j, i;
  float answer;
  float *signal;
  float totalProb;
  int rangeFactor;

  if (argc < 3) {
     printf("Usage: simpleconv [infile] [outfile]\n");
     exit(1);
  }

 /*
  * Accept other inputs 
  */

  printf("Enter step size: ");
  scanf("%f", &step);

  printf("Enter range factor (default = 1) : ");
  scanf("%d", &rangeFactor);

 /*
  * Open files
  */
  fd = fopen(argv[1], "r");
  if (!fd) {
     printf("Error opening infile\n");
   }
  fdout = fopen(argv[2], "w");
  if (!fdout) {
     printf("Error opening outfile\n");
   }

  /* count number of points */
  ptCount = 0;
  while (!feof(fd)) {
     fscanf(fd, "%f %f %d\n", &rate, &prob, &dummy);
     if (rate > maxRate) maxRate = rate;
     ptCount++;
  }
  /* allocate signal array */
  signal = (float *) calloc(ptCount * sizeof(float));
  if (!signal) {
     printf("Malloc error\n");
   }

  /* load signal array */
  fseek(fd,0,0);
  i = 0;
  while (!feof(fd)) {
     fscanf(fd, "%f %f %d\n", &rate, &prob, &dummy);
     signal[i++] = prob;
  }
  /* compute convolution directly */
  rate = 0.0;
  for (i=0; i < ptCount*rangeFactor; i++) {
     answer = 0.0;
     for (j=0; j < ptCount; j++) {
        if ((i - j >= 0) && (i - j < ptCount)) {
           answer += signal[i - j] * signal[j];
        } else { 
           answer += 0.0;
        }
     }
     fprintf(fdout, "%f %f\n", rate, answer);
     rate += step;
  }  

#ifdef DEBUG
  fprintf(fdout, "%f\n", totalProb); 
#endif
  fclose(fd);
  fclose(fdout);
}













